/******************************************************************************
 * @(#)reset.c : prolific machine reset functions
 *
 * Copyright (c) 2002 Prolific Technology Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Prolific 
 * Technology, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Prolific.
 *
 * Modification History:
 *   #000 2002-06-10 jedy    create file
 *   #001 2002-07-11 jim      modified to port to PL1071
 *   #002 2003-05-23 jim      revised to PL1091
 ******************************************************************************/
#include <linux/config.h>

void (*back_to_prom)(void) = (void (*)(void))0x00000000;

void pl_machine_restart(char *command)
{
    int s=0;
//JIM-CHECK !!!     
#if defined(CONFIG_ARCH_PL1071) || defined(CONFIG_ARCH_PL1091)
#else
    s = ST0_BEV; /* Enable prom exception handling */
    write_32bit_cp0_register(CP0_STATUS, s);
    asm("nop;break;nop;");
#endif
    back_to_prom();
}

void pl_machine_halt(void)
{
    int s=0;
#if defined(CONFIG_ARCH_PL1071) || defined(CONFIG_ARCH_PL1091)
#else
    s = ST0_BEV; /* Enable prom exception handling */
    write_32bit_cp0_register(CP0_STATUS, s);
    asm("nop;break;nop;");
#endif
    back_to_prom();
}

void pl_machine_power_off(void)
{
    int s=0;
#if defined(CONFIG_ARCH_PL1071) || defined(CONFIG_ARCH_PL1091)
#else
    s = ST0_BEV; /* Enable prom exception handling */
    write_32bit_cp0_register(CP0_STATUS, s);
    asm("nop;break;nop;");
#endif
    back_to_prom();
}
