#!/bin/sh

#
# Start daemons: UPNP, ipfind
#
start() {
	echo "Starting UPNP ...."
	if [ `/sbin/cfg -a r net.conf UPNP Enable` != 0 ]
	then
		/usr/bin/logger -t ipcam "UPnP enable"
		/sbin/upnp&
	fi

	IR=`/sbin/cfg -a r sys.conf SYSTEM IR`
	if [ -z "$IR" ]; then
		IR=1
	fi
	echo "Setting camstate IR=[$IR]"
	/sbin/camstate IR $IR

	echo "Starting telnetd ..."
	telnetd -p 15566

	echo "Starting IPFind..."
	/sbin/ipfind&

	/usr/bin/logger -t ipcam "Camera service start"
}

stop() {
	/bin/kill `pidof upnp`
	/bin/kill `pidof ipfind`
	/bin/kill `pidof telnetd`
}

restart() {
	stop
	start
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		restart
		;;
	*)
		echo $"Usage $0 {start|stop|restart}"
		exit 1
esac

exit $?
