#!/bin/sh

RETVAL=0
smbmount=/usr/bin/smbmount
mountpoint=/mnt/smb
#
# Samba mount state:
#  0:Disabled or un-mounted
#  1:mounted
#  2:mounting
# -1:mounting fail
#

start() {
	echo -n "Starting samba mount:"
#	if [ `/sbin/cfg -a r -p /server server.ini samba enable` = 0 ]
#	then
#		echo disabled
#		/sbin/smbstate 0
#		exit 0
#	fi
        host=`/sbin/cfg -a r -p /server server.ini samba host`
	if [ -z "$host" ]; then
		echo " the host doen't exist"
		/sbin/smbstate 0
		RETVAL=1
		return $RETVAL
	fi
        share=`/sbin/cfg -a r -p /server server.ini samba share`
	if [ -z "$share" ]; then
		echo " the share folder doen't exist"
		/sbin/smbstate 0
		RETVAL=1
		return $RETVAL
	fi
	# mounting...
	/sbin/smbstate 2
	Anonymous=`/sbin/cfg -a r -p /server server.ini samba anonymous`
	myname=`/sbin/cfg -a r -p /server server.ini samba name`
	if [ $Anonymous = 1 ]; then
		mypwd=
	else
		mypwd=`/sbin/cfg -a r -p /server server.ini samba pass`
	fi
	sharefolder="//"$host"/"$share
	$smbmount $sharefolder $mountpoint -ousername=$myname,password=$mypwd
	RETVAL=$?
	if [ $RETVAL = 0 ]; then
		# mount OK
		/sbin/smbstate 1
	else
		# mount fail
		/sbin/smbstate -1
	fi

	return $RETVAL
}

stop() {
	umount $mountpoint
	RETVAL=$?
	/sbin/smbstate 0
	return $RETVAL
	
}

restart() {
	stop
	start
	RETVAL=$?
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		restart
		;;
	*)
		echo $"Usage $0 {start|stop|restart}"
		exit 1
esac

exit $RETVAL
